/*
 * nrt.c
 *
 * Code generation for function 'nrt'
 *
 */

/* Include files */
#include "rt_nonfinite.h"
#include "nrt.h"
#include "eml_error.h"
#include "nrt_data.h"

/* Variable Definitions */
static emlrtRSInfo emlrtRSI = { 23, "nrt",
  "C:\\MATLAB\\MATLAB_WORK\\MATLAB_Coder\\ML_to_C_Presentation\\Demo\\Newton-Raphson\\nrt.m"
};

static emlrtRSInfo b_emlrtRSI = { 13, "newtonSearchAlgorithm",
  "C:\\MATLAB\\MATLAB_WORK\\MATLAB_Coder\\ML_to_C_Presentation\\Demo\\Newton-Raphson\\newtonSearchAlgorithm.m"
};

static emlrtRSInfo c_emlrtRSI = { 31, "newtonSearchAlgorithm",
  "C:\\MATLAB\\MATLAB_WORK\\MATLAB_Coder\\ML_to_C_Presentation\\Demo\\Newton-Raphson\\newtonSearchAlgorithm.m"
};

static emlrtRSInfo d_emlrtRSI = { 32, "newtonSearchAlgorithm",
  "C:\\MATLAB\\MATLAB_WORK\\MATLAB_Coder\\ML_to_C_Presentation\\Demo\\Newton-Raphson\\newtonSearchAlgorithm.m"
};

static emlrtRSInfo e_emlrtRSI = { 37, "mpower",
  "C:\\MATLAB\\R2014a\\toolbox\\eml\\lib\\matlab\\ops\\mpower.m" };

static emlrtRSInfo f_emlrtRSI = { 42, "power",
  "C:\\MATLAB\\R2014a\\toolbox\\eml\\lib\\matlab\\ops\\power.m" };

static emlrtRSInfo g_emlrtRSI = { 56, "power",
  "C:\\MATLAB\\R2014a\\toolbox\\eml\\lib\\matlab\\ops\\power.m" };

static emlrtBCInfo emlrtBCI = { 1, 50, 16, 9, "h", "newtonSearchAlgorithm",
  "C:\\MATLAB\\MATLAB_WORK\\MATLAB_Coder\\ML_to_C_Presentation\\Demo\\Newton-Raphson\\newtonSearchAlgorithm.m",
  0 };

/* Function Definitions */
void nrt(const emlrtStack *sp, real_T varargin_1, real_T varargin_2, real_T
         varargin_3, real_T *nth_rt, real_T *iterations, real_T hstry[50])
{
  int32_T notDone;
  real_T a;
  int32_T cnt;
  real_T slope;
  emlrtStack st;
  emlrtStack b_st;
  emlrtStack c_st;
  emlrtStack d_st;
  emlrtStack e_st;
  emlrtStack f_st;
  st.prev = sp;
  st.tls = sp->tls;
  b_st.prev = &st;
  b_st.tls = st.tls;
  c_st.prev = &b_st;
  c_st.tls = b_st.tls;
  d_st.prev = &c_st;
  d_st.tls = c_st.tls;
  e_st.prev = &d_st;
  e_st.tls = d_st.tls;
  f_st.prev = &e_st;
  f_st.tls = e_st.tls;

  /* This function will use a Newton Search Technique to find */
  /* the nth root of a number, a, to the tolerance, tol. */
  /*  The square root */
  /*  nrt(10,2), or nrt(10,2,1e-9) */
  /*  The "n" root */
  /*  nrt(10,n), or nrt(10,n,1e-9) */
  if (varargin_1 < 0.0) {
    *nth_rt = 0.0;
    *iterations = 0.0;
    memset(&hstry[0], 0, 50U * sizeof(real_T));
  } else {
    st.site = &emlrtRSI;

    /*  Given, "a", this function finds the nth root of a */
    /*  number by finding where: x^n-a=0. */
    notDone = 1;
    *nth_rt = 0.0;

    /* Refined Guess Initialization */
    a = 1.0;

    /* Initial Guess */
    cnt = 0;
    memset(&hstry[0], 0, 50U * sizeof(real_T));
    hstry[0] = 1.0;
    while (notDone != 0) {
      cnt++;
      b_st.site = &b_emlrtRSI;

      /*  Our function is f=a^n-b and it's derivative is n*a^(n-1). */
      c_st.site = &c_emlrtRSI;
      d_st.site = &e_emlrtRSI;
      e_st.site = &f_emlrtRSI;
      if ((a < 0.0) && (muDoubleScalarFloor(varargin_2) != varargin_2)) {
        f_st.site = &g_emlrtRSI;
        eml_error(&f_st);
      }

      c_st.site = &d_emlrtRSI;
      d_st.site = &e_emlrtRSI;
      e_st.site = &f_emlrtRSI;
      if ((a < 0.0) && (muDoubleScalarFloor(varargin_2 - 1.0) != varargin_2 -
                        1.0)) {
        f_st.site = &g_emlrtRSI;
        eml_error(&f_st);
      }

      slope = varargin_2 * muDoubleScalarPower(a, varargin_2 - 1.0);

      /* square */
      *nth_rt = -((muDoubleScalarPower(a, varargin_2) - varargin_1) - slope * a)
        / slope;

      /* The new guess */
      hstry[emlrtDynamicBoundsCheckFastR2012b(cnt, 1, 50, &emlrtBCI, &st) - 1] =
        *nth_rt;
      if (muDoubleScalarAbs(*nth_rt - a) < varargin_3) {
        /* Break if it's converged */
        notDone = 0;
      } else if (cnt > 49) {
        /* after 50 iterations, stop */
        notDone = 0;
        *nth_rt = 0.0;
      } else {
        a = *nth_rt;
      }

      emlrtBreakCheckFastR2012b(emlrtBreakCheckR2012bFlagVar, &st);
    }

    /*  Determine iterations */
    *iterations = 0.0;
    notDone = 0;
    while ((notDone < 50) && (hstry[notDone] != 0.0)) {
      (*iterations)++;
      notDone++;
      emlrtBreakCheckFastR2012b(emlrtBreakCheckR2012bFlagVar, sp);
    }

    /* iterations=length(find(hstry~=0)); */
  }
}

/* End of code generation (nrt.c) */
